using System;
using System.Collections.Generic;
using System.Text;

namespace BennettAdelson.Samples.FXCopRuleExplorer
{
    /// <summary>
    /// This class contains Sample code useful only to test the Custom Rule
    /// </summary>
    /// <remarks>
    /// Please don't write any code like this for real :-)
    /// </remarks>
    public class sampleCodeToAnalyze
    {
        #region Methods that DO NOT GENERATE Policy Violations on the Custom Rule
        public int OkMethod()
        {
            int a = 1, b = 2, c = 3, d = 4, goodVarName = 5;
            return a + b + c + d + goodVarName;
        }

        private int ComplexOKMethod()
        {
            string someDebugMessage = "msg1";
            Console.WriteLine("Entering the Bad Method: {0}", someDebugMessage);
            if (string.IsNullOrEmpty(someDebugMessage))
            {
                string someOtherDebugMessage = "msg2";
                Console.WriteLine("Entering the Bad Method's nested block: {0}", someOtherDebugMessage);

                if (DateTime.Now.Millisecond % 2 == 0)
                {
                    int a = 1, b = 2, c = 3, d = 4, goodVarName = 5;
                    return a + b + c + d + goodVarName;
                }
            }

            return 0;
        }

        public void NullMethod() { }
        public int NullMethodWithReturn() { return 5; } 
        #endregion

        #region Methods that Generate Policy Violations on the Custom Rule
        public int SimpleBadMethod()
        {
            int a = 1, b = 2, c = 3, d = 4, ee = 5, ff = 6;
            return a + b + c + d + ee + ff;
        }

        private int ComplexBadMethod()
        {
            string someDebugMessage = "msg1";
            Console.WriteLine("Entering the Bad Method: {0}", someDebugMessage);
            if (string.IsNullOrEmpty(someDebugMessage))
            {
                string someOtherDebugMessage = "msg2";
                Console.WriteLine("Entering the Bad Method's nested block: {0}", someOtherDebugMessage);

                if (DateTime.Now.Millisecond % 2 == 0)
                {
                    int a = 1, b = 2, c = 3, d = 4, ee = 5, ff = 6;
                    return a + b + c + d + ee + ff;
                }
            }

            return 0;
        }
        #endregion
    }
}
